#include<stdio.h>
#include "i2c.h"

void SEARCH_LIMIT_DEFINITIONS (char Schritt, char RSSI, char SNR, int H_FREQ, int L_FREQ, char DE)
{
	// FM Suchlauf Grenzen
	// Obergrenze 108,00 MHz
	start ();
	send (0x22);
	send (0x12);
	send (0x00);
	send (0x14);
	send (0x01);
	send (H_FREQ>>8);
	send (H_FREQ);
	stop ();
	_delay_ms(100);
	
	// Untergrenze 87,50 MHz
	
	start ();
	send (0x22);
	send (0x12);
	send (0x00);
	send (0x14);
	send (0x00);
	send (L_FREQ>>8);
	send (L_FREQ);
	stop();
	_delay_ms(100);
	
	// Schritt fr Suchlauf 100 kHz
	
	start ();
	send (0x22);
	send (0x12);
	send (0x00);
	send (0x14);
	send (0x02);
	send (0x00);
	send (Schritt);
	stop ();
	_delay_ms(100);
	
	//FM De-Emphasis to 50 s
	start();
	send(0x12);			// Property-bit
	send(0x00);			//
	send(0x11);
	send(0x00);
	send(0x00);
	send(DE);			// 1 Fr 50 S 0 fr 75 S
	stop();
	_delay_ms(100);
	
	// Suchlauf stoppen wenn RSSI = 20 dbV ist
	
	start ();
	send (0x22);
	send (0x12);
	send (0x00);
	send (0x08);
	send (0x04);
	send (0x00);
	send (RSSI);
	stop ();
	_delay_ms(100);
	
	// Suchlauf stoppen, wenn SNR = 6 dbV ist
	
	start ();
	send (0x22);
	send (0x12);
	send (0x00);
	send (0x11);
	send (0x03);
	send (0x00);
	send (SNR);
	stop ();
	_delay_ms(100);
}

void AUDIO_MODE (char stereo, char mono)
{
	//FM Stereo & Mono berblendung (Rauschunterdrckung) nach RSSSI
	start();
	send(0x22);
	send(0x12);
	send(0x00);
	send(0x11);
	send(0x05);
	send(0x00);
	send(stereo); // Bis ... findet eine berblendung statt
	stop();
	_delay_ms(100);
	
	start();
	send(0x22);
	send(0x12);
	send(0x00);
	send(0x11);
	send(0x06);
	send(0x00);
	send(mono); // Bis ... findet eine Wiedergabe in Mono statt
	stop();
	_delay_ms(100);
}

void TURN_ON_AND_DEFINITIONS (void)
{
	// Anschalten im FM Modus //
	start();
	send(0x22);			// Controllbyte write
	send(0x01); 		// Power On
	send(0x10); 		// Oszillator Quarz 32,768 kHz, Es werden die Ausgnge GPIO2 und RFCLK definiert
	send(0x05);			// Audioausgabe ber Standart analog
	stop();
	_delay_ms(100);
	
	// RefCLCK 32768 Uhrenquarz fr AFC (Automatic Frequency Control)
	start();
	send(0x12);			// Property-bit
	send(0x00);			//
	send(0x02);
	send(0x01);
	send(0x7E);
	send(0xF4);
	stop();
	_delay_ms(100);
}

void TUNING_OPTIONS (void)
{
	// FM TUNE FREQ ERROR CONTROLL +- 50 kHz
	start();
	send(0x22);
	send(0x12);
	send(0x00);
	send(0x11);
	send(0x08);
	send(0x00);
	send(0x32);
	stop();
	_delay_ms(100);
	
	//FM Rauschunterdrckung bis SNR >= 6 dB
	start();
	send(0x22);
	send(0x12);
	send(0x00);
	send(0x13);
	send(0x03);
	send(0x00);
	send(0x06);
	stop();
	_delay_ms(100);
	
	//FM Soft Mute 6 dB
	start();
	send(0x22);
	send(0x12);
	send(0x00);
	send(0x13);
	send(0x00);
	send(0x00);
	send(0x0A);
	stop();
	_delay_ms(100);
	
	// UKW Frequenz setzen //
	start();
	send(0x22);
	send(0x20);
	send(0x00);
	send(Sender >> 8);
	send(Sender);
	send(0x00);
	stop();
	_delay_ms(100);
}

int VOLUME_SET (int volume)
{
	//Volume 0....63
	start();
	send(0x22);
	send(0x12);
	send(0x00);
	send(0x40);
	send(0x00);
	send(0x00);
	send(volume);
	stop();
	_delay_ms(100);
	return volume;
}

int FM_SET_FREQUENCY (int Sender)
{
	// UKW Frequenz setzen //
	start();
	send(0x22);
	send(0x20);
	send(0x00);
	send(Sender >>8);
	send(Sender);
	send(0x00);
	stop();
	return Sender;
}

void CALL_FM_RSQ_DATA (unsigned char *zsp_4, unsigned char *zsp_5, signed char *zsp_7, unsigned char *zsp_3)
{
	start();
	send(0x22);
	send(0x23);
	send(0x00);
	stop();
	_delay_ms(10);
	start();
	send(0x23);
	status = empfack();
	resp1 = empfack();
	resp2 = empfack();
	*zsp_3 = empfack();
	*zsp_4 = empfack();
	*zsp_5 = empfack();
	resp6 = empfack();
	*zsp_7 = empfnack();
	stop();
	_delay_ms(10);
}
void TURN_OFF (void)
{
	start();
	send(0x22);
	send(0x11);
	stop();
}

void SEEK_UP (void)
{
	start();
	send(0x22);
	send(0x21);
	send(0x0C);
	stop();
}

void SEEK_DOWN (void)
{
	start();
	send(0x22);
	send(0x21);
	send(0x04);
	stop();
}

void CALL_FM_FREQUENCY(void)
{
	start();
	send(0x22);
	send(0x22);
	send(0x01);
	stop();
}

/*void CALL_AM_RSQ_DATA(void)
{
	
	start();
	send(0x22);
	send(0x43);
	send(0x01);
	stop();
	_delay_ms(20);
	start();
	send(0x23);
	status = empfack();
	resp1 = empfack();
	resp2 = empfack();
	resp3 = empfack();
	zsp_4 = empfack();
	zsp_5 = empfack();
	resp6 = empfack();
	zsp_7 = empfnack();
	stop();
	_delay_ms(20);
	
}*/

void GET_FM_UPPERSIDE_FREQ(unsigned int *Uebergabe_Frequenz)
{
	unsigned int Frequenz_FM;
	start();
	send(0x22);
	send(0x22);
	send(0x01);
	stop();
	_delay_ms(100);
	start();
	send(0x23);
	status = empfack();
	resp1 = empfack();
	Frequenz_FM = empfack() << 8;
	Frequenz_FM += empfack();
	resp4 = empfack();
	resp5 = empfack();
	resp6 = empfack();
	resp7 = empfnack();
	stop();
	//*Uebergabe_Kontrollbit=Frequenz_Kontroll_Bit;
	*Uebergabe_Frequenz=Frequenz_FM;
}



void GET_FM_DOWNSIDE_FREQ(unsigned int *Uebergabe_Frequenz)
{
	unsigned int Frequenz_FM;
	start();
	send(0x22);
	send(0x22);
	send(0x01);
	stop();
	_delay_ms(100);
	start();
	send(0x23);
	status = empfack();
	resp1 = empfack();
	Frequenz_FM = empfack() << 8;
	Frequenz_FM -= empfack();
	resp4 = empfack();
	resp5 = empfack();
	resp6 = empfack();
	resp7 = empfnack();
	stop();
	//*Uebergabe_Kontrollbit=Frequenz_Kontroll_Bit;
	*Uebergabe_Frequenz=Frequenz_FM;
}

