/////////////////////////////////////////////////////////////////////////////////////////////
//---------------------Drehgeber 1. Stelle-------------------------------------------------//
/////////////////////////////////////////////////////////////////////////////////////////////
//*****************************************************************************************//
///////////////////////Drehgeber fr Senderwahl und Lautstrke///////////////////////////////
//-----------------------------------------------------------------------------------------//
/////////////////////////////////////////////////////////////////////////////////////////////

// Eingebundene Dateien //

#include <avr/io.h>
#include "defi.h"

#define F_CPU 8000000UL
#include <util/delay.h>
#include <avr/interrupt.h>

//Variablen
volatile int8_t enc_delta;
volatile int8_t enc_delta_2;          // -128 ... 127
static int8_t last;
static int8_t last_2;


void encode_init_1( void ) // Senderwahl
{
	int8_t new;
	
	new = 0;
	if( PHASE_A )
	new = 3;
	if( PHASE_B )
	new ^= 1;                   // convert gray to binary
	last = new;                   // power on state
	enc_delta = 0;


	TCCR2 = 1<<WGM21^1<<CS22; // CTC2, Prescaler 64
	OCR2 = (uint8_t)(XTAL / 128.0 * 1e-3 - 0.5);   // 1ms
	TIMSK |= 1<<OCIE2;
}
void encode_init_2( void ) // Lautstrke
{
	int8_t new_2;
	
	new_2 = 0;
	if( PHASE_C )
	new_2 = 3;
	if( PHASE_D )
	new_2 ^= 1;                   // convert gray to binary
	last_2 = new_2;                   // power on state
	enc_delta_2 = 0;


	TCCR2 = 1<<WGM21^1<<CS22; // CTC2, Prescaler 64
	OCR2 = (uint8_t)(XTAL / 64.0 * 1e-3 - 0.5);   // 1ms
	TIMSK |= 1<<OCIE2;
}


ISR( TIMER2_COMP_vect )             // 1ms for manual movement
{
	int8_t new, diff;
	
	new = 0;
	if( PHASE_A )
	new = 3;
	if( PHASE_B )
	new ^= 1;                   // convert gray to binary
	diff = last - new;                // difference last - new
	if( diff & 1 )
	{               // bit 0 = value (1)
		last = new;                 // store new as next last
		enc_delta += (diff & 2) - 1;        // bit 1 = direction (+/-)
	}
	
	int8_t new_2, diff_2;
	
	new_2 = 0;
	if( PHASE_C )
	new_2 = 3;
	if( PHASE_D )
	new_2 ^= 1;                   // convert gray to binary
	diff_2 = last_2 - new_2;                // difference last - new
	if( diff_2 & 1 )
	{               // bit 0 = value (1)
		last_2 = new_2;                 // store new as next last
		enc_delta_2 += (diff_2 & 2) - 1;        // bit 1 = direction (+/-)
	}
}

int8_t encode_read_1( void )         // read two step encoders
{
	int8_t val;
	
	cli();
	val = enc_delta;
	enc_delta = val & 3;
	sei();
	return val >> 2;
}
int8_t encode_read_2( void )         // read two step encoders
{
	int8_t val;
	
	cli();
	val = enc_delta_2;
	enc_delta_2 = val & 3;
	sei();
	return val >> 2;
}