/////////////////////////////////////////////////////////////////////////////////////////////
// TWI Schnittstelle (I2C) //
/////////////////////////////////////////////////////////////////////////////////////////////

// Eingebundene Datei //
#include "main.h"

//Bitrate//

/* I2C initialisierung */
void init_i2c (void)
{
	// Hier werden die Registergren definiert //
	TWBR = 192; // Two Wire Interface Data Bit Register
	TWSR = 0; // Two Wire Interface Status Register
}


//Startsignal//
void start (void)
{
	TWCR = (1 << TWINT) | (1 << TWSTA) | (1 << TWEN);
	asm volatile ("NOP");
	while(!(TWCR & (1<<TWINT))){asm volatile ("NOP");}
}

//Stopsignal//
void stop (void)
{
	TWCR = (1 << TWINT) | (1 << TWSTO) | (1 << TWEN);
	asm volatile ("NOP");
	while(!(TWCR &(1<<TWSTO))){asm volatile ("NOP");}
}

// senden //
void send (unsigned char daten)
{
	TWDR = daten;
	TWCR = (1 << TWINT) | (1 << TWEN);
	asm volatile ("NOP");
	while(!(TWCR &(1<<TWINT))){asm volatile ("NOP");}
}

// empfangen //
unsigned char empfack (void)
{
	TWCR = (1 << TWINT) | (1 << TWEN) | (1 << TWEA);
	asm volatile ("NOP");
	while(!(TWCR &(1<<TWINT))){asm volatile ("NOP");}
	return TWDR;
}

// ACK Impuls //
unsigned char empfnack (void)
{
	TWCR = (1 << TWINT) | (1 << TWEN);
	asm volatile ("NOP");
	while(!(TWCR &(1<<TWINT))){asm volatile ("NOP");}
	return TWDR;
}
